
/*  A Bison parser, made from ..\..\..\src\cfg.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	_LOGFILE	258
#define	_LOGLEVEL	259
#define	_NODELIST	260
#define	_INDEXFILE	261
#define	_NODELISTPATH	262
#define	_ADDRESS	263
#define	_SYSOPNAME	264
#define	_USEOWNZONE	265
#define	_FORCEINTL	266
#define	_LOOPSTR	267
#define	_SCANDIR	268
#define	_MASK	269
#define	_SMASK	270
#define	_PMASK	271
#define	_BODYMASK	272
#define	_SBODYMASK	273
#define	_PBODYMASK	274
#define	_KLUDGEMASK	275
#define	_SKLUDGEMASK	276
#define	_PKLUDGEMASK	277
#define	_ACTION	278
#define	_MAXAGE	279
#define	_BADMESSAGES	280
#define	_NOLOGIGNORE	281
#define	_AKA	282
#define	_SKIPHIDDENFILES	283
#define	_FILEINBOUND	284
#define	_OUTBOUND	285
#define	_ADDTONULLPKT	286
#define	_TEMPMAIL	287
#define	_TRAFFICLOG	288
#define	_PASSWORD	289
#define	_UTC	290
#define	_ORIGIN	291
#define	_TEARLINE	292
#define	_INCLUDE	293
#define	_APKTDIR	294
#define	_CHECKPOINTS	295
#define	_SETVIAALWAYS	296
#define	_CREATEMISSINGBASE	297
#define	_USENEWVIA	298
#define	_SCRIPTMASK	299
#define	_SSCRIPTMASK	300
#define	_PSCRIPTMASK	301
#define	_MAXATTACHSIZE	302
#define	_SEMAPHORE	303
#define	_SCRIPTFILE	304
#define	_KILLROUTEDMESSAGE	305
#define	_MAXNODELISTAGE	306
#define	_SOFTCHECKINNODELIST	307
#define	_TIMESTAMPFILE	308
#define	_TRAFFICLOGTEMPLATE	309
#define	_USEASO	310
#define	_CRLF	311
#define	_SKIP	312
#define	_DELETE	313
#define	_EXIT	314
#define	_MOVE	315
#define	__EOF	316
#define	_STRING	317
#define	_BEFOREROUTE	318
#define	_AFTERROUTE	319
#define	_DIGIT_	320
#define	_RENUMBER	321
#define	_UNPACK	322
#define	_DAILY	323
#define	_WEEKLY	324
#define	_FLAG	325
#define	_NEVER	326
#define	_HARD	327
#define	_SOFT	328
#define	_ALWAYS	329
#define	_ADDNOTE	330
#define	_COPY	331
#define	_REWRITE	332
#define	_IGNORE	333
#define	_DISPLAY	334
#define	_DELFILE	335
#define	_NEWMSG	336
#define	_WRITEFILE	337
#define	_APPENDTOFILE	338
#define	_CALL	339
#define	_ROUTE	340
#define	_POLL	341
#define	_DELETEATTACH	342
#define	_CHANGEPATH	343
#define	_MOVEATTACH	344
#define	_COPYATTACH	345
#define	_SPLIT	346
#define	_RECODE	347
#define	_HOLD	348
#define	_CRASH	349
#define	_DIRECT	350
#define	_NORMAL	351
#define	LEXERR	352



#define YYDEBUG 0
/* #define YYERROR_VERBOSE */

#include <stdlib.h>
#ifdef __WATCOMC__
   #include <malloc.h>
#endif
#include "msg.hpp"
#include "outbound.hpp"
#include "fidoaddr.h"
#include "vars.hpp"
#include "configure.hpp"
#include "constant.hpp"
#include "log.hpp"
#include "aka.hpp"
#include "age.hpp"
#include "scandir.hpp"
#include "attach.hpp"
#include "badmsg.hpp"
#include "passwd.hpp"
#include "nodelist.hpp"
#include "script.hpp"

extern int DetectError;
extern int NoTokensF;

extern FA   cffa;
extern FA   cffa1;
extern FA   cffa2;

static int brf = FALSE, arf = FALSE, renumberf = FALSE, unpackf = FALSE;
static ScanDir *wsd = NULL;
static char *FileName = NULL;
static tTimes *tt;
static IndBiList<tTimes> *_TTimes;
static MSGBASE *mbase;
static Mask *msk = NULL;
static int MaskMode;
static int rc;
static int FlagMode = 0;
static Action *act = NULL;

static void CheckETTime(void) {
time_t tmt;
   if (tt->_ETime != 0 && tt->_ETime < tt->_STime) {
      tmt = tt->_ETime;
      tt->_ETime = (23*60*60)+(59*60)+59;
      tt->_ETime += TimeOfBeginOfDay(-1);
      _TTimes->AddToEnd(tt);
      tt = new tTimes;
      tt->_STime = TimeOfBeginOfDay(-1);
      tt->_ETime = tmt;
   }
}

static int PrepareMask(Mask &m) {
ScanDir *sd;
char ErrMess[128];

   CHP = 23700;
   sd = ScanDirs.GetLast();
   if (sd == NULL) {
      strcpy(ErrMess,"'");
      strcat(ErrMess,m.MaskName());
      strcat(ErrMess,":' without 'ScanDir:'");
      yyerror(ErrMess);
      return -1;
   }
   m.sd = sd;
   return 0;
}

static void AddReadyMask(Mask &m) {
ScanDir *sd;

   switch (PrevMask) {
      case 0: // first mask.
      case 1: // after action.
         LastDo = new DoList();
         sd = ScanDirs.GetLast();
         sd->_DoLists.AddToEnd(LastDo);
         PrevMask = 2;
         break;
      case 2: // after MASK.
         break;
   }
   LastDo->AddMask(m);
}


static int CheckMaskMode(char *f) {
char Buff[128];
   if (MaskMode != 0) {
      strcpy(Buff,"You can use '");
      strcat(Buff,f);
      strcat(Buff,"' flag only in 'Mask:'.");
      yyerror(Buff);
      return -1;
   }
   return 0;
}


static int ctoi(char *s) {
   char *foo;
   int res;

   res = strtoul(s, &foo, 0);
   if (*foo)	/* parse error */
      return 0;
   return res;
}




typedef union {
   int          in;
   char         *ch;
   long         ln;
   KillModeT    kmode;
   CheckPointsT pmode;
   tBadMsgMode  bmode;
   time_t       t;
   PKTMode      pktmode;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		441
#define	YYFLAG		-32768
#define	YYNTBASE	141

#define YYTRANSLATE(x) ((unsigned)(x) <= 352 ? yytranslate[x] : 274)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   107,     2,   137,   104,   106,   139,     2,     2,
     2,   105,    98,     2,    99,   100,   140,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   103,     2,     2,
     2,     2,     2,   138,   109,     2,     2,     2,   114,     2,
     2,     2,     2,     2,     2,   122,     2,     2,     2,   102,
     2,     2,   129,     2,     2,     2,     2,     2,     2,     2,
   135,     2,   136,     2,     2,     2,   108,   110,   111,   112,
   113,   115,   116,   117,   118,   119,   120,   121,   123,   124,
   125,   101,   126,   127,   128,   130,   131,   132,     2,   133,
   134,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,    10,    13,    16,    19,    22,    25,
    28,    31,    34,    37,    40,    43,    46,    49,    52,    55,
    58,    61,    64,    67,    70,    73,    76,    79,    82,    85,
    88,    91,    94,    97,   100,   103,   106,   109,   112,   115,
   118,   121,   124,   127,   130,   133,   136,   139,   142,   145,
   148,   151,   154,   157,   160,   163,   164,   168,   170,   173,
   176,   180,   183,   184,   185,   191,   194,   197,   198,   202,
   205,   207,   209,   211,   214,   216,   218,   220,   223,   226,
   229,   232,   235,   239,   240,   242,   245,   248,   251,   254,
   257,   260,   263,   266,   269,   272,   273,   278,   281,   283,
   285,   287,   290,   293,   295,   298,   301,   302,   306,   309,
   310,   315,   317,   319,   320,   323,   325,   327,   329,   330,
   334,   335,   339,   340,   343,   345,   349,   353,   355,   357,
   358,   363,   364,   367,   369,   373,   374,   376,   377,   381,
   382,   386,   387,   391,   392,   393,   394,   395,   396,   397,
   410,   412,   414,   416,   418,   420,   422,   425,   427,   428,
   430,   432,   433,   436,   438,   441,   443,   444,   448,   449,
   453,   455,   457,   459,   461,   463,   465,   467,   469,   471,
   473,   475,   477,   479,   481,   483,   485,   487,   489,   491,
   493,   495,   497,   499,   501,   503,   505,   507,   509,   511,
   514,   517,   520,   521,   526,   529,   532,   535,   536,   541,
   544,   547,   550,   551,   554,   555,   556,   562,   563,   567,
   569,   571,   573,   575,   577,   579,   581,   583,   585,   587,
   589,   591,   593,   595,   597,   599,   601,   603,   605,   607,
   609,   612,   615,   618,   619,   623,   626,   628,   631,   634,
   635,   641,   645,   649,   654,   657,   658,   663,   665,   667,
   669,   671,   672,   677,   680,   683,   686,   689,   692,   694,
   697,   699,   701,   703,   705,   707,   709,   711,   715,   719,
   721,   723,   729,   731
};

static const short yyrhs[] = {    -1,
   141,   142,     0,   239,    56,     0,   147,    56,     0,   151,
    56,     0,   153,    56,     0,    31,    56,     0,   148,    56,
     0,   152,    56,     0,   229,    56,     0,   230,    56,     0,
   231,    56,     0,   155,    56,     0,    42,    56,     0,   174,
    56,     0,    11,    56,     0,   163,    56,     0,   167,    56,
     0,   157,    56,     0,   224,    56,     0,   225,    56,     0,
   226,    56,     0,   161,    56,     0,   162,    56,     0,   168,
    56,     0,   200,    56,     0,   202,    56,     0,   204,    56,
     0,   175,    56,     0,   169,    56,     0,   170,    56,     0,
   164,    56,     0,   166,    56,     0,    26,    56,     0,   171,
    56,     0,   176,    56,     0,   234,    56,     0,   235,    56,
     0,   236,    56,     0,    41,    56,     0,    28,    56,     0,
    52,    56,     0,   159,    56,     0,   160,    56,     0,    43,
    56,     0,    10,    56,     0,    55,    56,     0,   180,    56,
     0,   172,    56,     0,   173,    56,     0,   178,    56,     0,
   182,    56,     0,   146,    56,     0,   145,    56,     0,   144,
    56,     0,     0,     1,    56,   143,     0,    56,     0,    49,
    62,     0,    54,    62,     0,    48,    65,    62,     0,    38,
    62,     0,     0,     0,    27,   149,   268,   150,   268,     0,
    53,    62,     0,    39,    62,     0,     0,     8,   154,   268,
     0,    40,   156,     0,    71,     0,    72,     0,    73,     0,
    50,   158,     0,    74,     0,    71,     0,    70,     0,     9,
    62,     0,    37,    62,     0,     3,    62,     0,     4,    65,
     0,    36,    62,     0,     5,    62,   165,     0,     0,    65,
     0,     7,    62,     0,     6,    62,     0,    12,    62,     0,
    47,    65,     0,    51,    65,     0,    30,    62,     0,    32,
    62,     0,    33,    62,     0,    29,    62,     0,    24,    65,
     0,     0,    34,    62,   177,   268,     0,    25,   179,     0,
    57,     0,    59,     0,    58,     0,    60,    62,     0,    35,
   181,     0,    65,     0,    98,    65,     0,    99,    65,     0,
     0,    13,   183,   184,     0,   186,   199,     0,     0,    62,
   185,   187,   199,     0,    63,     0,    64,     0,     0,   187,
   188,     0,    66,     0,    67,     0,   189,     0,     0,    68,
   190,   192,     0,     0,    69,   191,   197,     0,     0,   192,
   193,     0,   195,     0,   195,    99,   195,     0,   194,   100,
   195,     0,   101,     0,   102,     0,     0,    65,   196,   103,
    65,     0,     0,   197,   198,     0,    65,     0,    65,    99,
    65,     0,     0,   251,     0,     0,    14,   201,   206,     0,
     0,    15,   203,   206,     0,     0,    16,   205,   206,     0,
     0,     0,     0,     0,     0,     0,   207,   213,   208,   268,
   209,   213,   210,   268,   211,   214,   212,   217,     0,    62,
     0,   104,     0,   105,     0,   106,     0,    62,     0,   105,
     0,   216,    65,     0,   105,     0,     0,   107,     0,   105,
     0,     0,   218,   219,     0,   220,     0,   219,   220,     0,
   223,     0,     0,    98,   221,   223,     0,     0,    99,   222,
   223,     0,   108,     0,   109,     0,   110,     0,   111,     0,
   112,     0,   113,     0,   114,     0,   115,     0,   116,     0,
   117,     0,   118,     0,   119,     0,   120,     0,   121,     0,
   122,     0,   123,     0,   124,     0,   125,     0,   101,     0,
   126,     0,   127,     0,   128,     0,   129,     0,   130,     0,
   131,     0,   132,     0,   133,     0,   134,     0,    65,     0,
    20,   227,     0,    21,   227,     0,    22,   227,     0,     0,
   228,   214,   214,   215,     0,    17,   232,     0,    18,   232,
     0,    19,   232,     0,     0,   233,   214,   215,   215,     0,
    44,   237,     0,    45,   237,     0,    46,   237,     0,     0,
   238,    62,     0,     0,     0,    23,   240,   243,   241,   242,
     0,     0,   135,   189,   136,     0,   244,     0,    58,     0,
   245,     0,   246,     0,   247,     0,    78,     0,   249,     0,
   250,     0,   252,     0,   253,     0,   255,     0,   256,     0,
   257,     0,   258,     0,   261,     0,    87,     0,   263,     0,
   264,     0,   265,     0,   266,     0,   267,     0,    75,    62,
     0,    60,    62,     0,    76,    62,     0,     0,    77,   248,
   206,     0,    79,    62,     0,   251,     0,    70,    62,     0,
    80,    62,     0,     0,    81,   254,    62,    62,   206,     0,
    82,    62,    62,     0,    83,    62,    62,     0,    84,    62,
    62,    62,     0,    84,    62,     0,     0,    85,   260,   259,
   268,     0,    93,     0,    94,     0,    95,     0,    96,     0,
     0,    86,   260,   262,   268,     0,    88,    62,     0,    89,
    62,     0,    90,    62,     0,    91,    65,     0,    92,    62,
     0,   269,     0,   107,   269,     0,   272,     0,   270,     0,
   105,     0,   137,     0,   138,     0,   104,     0,   106,     0,
   106,   100,    65,     0,   272,   100,   271,     0,   273,     0,
   139,     0,   273,   103,   273,   140,   273,     0,    65,     0,
   105,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   166,   167,   171,   172,   177,   178,   179,   185,   186,   187,
   188,   189,   190,   191,   197,   198,   204,   205,   206,   207,
   208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
   218,   219,   220,   221,   227,   228,   229,   230,   231,   232,
   238,   244,   250,   251,   252,   258,   264,   270,   271,   272,
   273,   274,   275,   276,   277,   278,   279,   281,   287,   294,
   301,   309,   312,   312,   313,   322,   330,   338,   339,   347,
   350,   351,   352,   355,   358,   359,   360,   363,   371,   379,
   387,   395,   403,   411,   412,   415,   423,   431,   439,   447,
   455,   463,   471,   479,   487,   496,   505,   513,   521,   522,
   523,   524,   527,   535,   536,   537,   542,   555,   566,   567,
   584,   587,   588,   591,   592,   595,   604,   617,   627,   634,
   640,   647,   655,   656,   666,   670,   675,   696,   697,   700,
   709,   721,   722,   730,   739,   751,   752,   757,   757,   763,
   763,   769,   769,   775,   783,   787,   799,   803,   823,   827,
   832,   833,   834,   835,   838,   839,   842,   849,   852,   853,
   856,   857,   858,   859,   860,   863,   864,   865,   865,   866,
   868,   869,   879,   880,   881,   882,   888,   894,   895,   905,
   906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
   916,   917,   918,   919,   920,   921,   922,   928,   929,   944,
   950,   956,   962,   970,   979,   985,   991,   997,  1005,  1015,
  1021,  1027,  1033,  1041,  1053,  1066,  1070,  1072,  1073,  1076,
  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
  1099,  1112,  1133,  1154,  1158,  1163,  1169,  1175,  1178,  1184,
  1188,  1225,  1239,  1253,  1266,  1272,  1272,  1290,  1291,  1292,
  1293,  1296,  1296,  1310,  1320,  1334,  1344,  1354,  1406,  1407,
  1410,  1411,  1412,  1419,  1426,  1433,  1440,  1447,  1460,  1463,
  1464,  1467,  1476,  1477
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","_LOGFILE",
"_LOGLEVEL","_NODELIST","_INDEXFILE","_NODELISTPATH","_ADDRESS","_SYSOPNAME",
"_USEOWNZONE","_FORCEINTL","_LOOPSTR","_SCANDIR","_MASK","_SMASK","_PMASK","_BODYMASK",
"_SBODYMASK","_PBODYMASK","_KLUDGEMASK","_SKLUDGEMASK","_PKLUDGEMASK","_ACTION",
"_MAXAGE","_BADMESSAGES","_NOLOGIGNORE","_AKA","_SKIPHIDDENFILES","_FILEINBOUND",
"_OUTBOUND","_ADDTONULLPKT","_TEMPMAIL","_TRAFFICLOG","_PASSWORD","_UTC","_ORIGIN",
"_TEARLINE","_INCLUDE","_APKTDIR","_CHECKPOINTS","_SETVIAALWAYS","_CREATEMISSINGBASE",
"_USENEWVIA","_SCRIPTMASK","_SSCRIPTMASK","_PSCRIPTMASK","_MAXATTACHSIZE","_SEMAPHORE",
"_SCRIPTFILE","_KILLROUTEDMESSAGE","_MAXNODELISTAGE","_SOFTCHECKINNODELIST",
"_TIMESTAMPFILE","_TRAFFICLOGTEMPLATE","_USEASO","_CRLF","_SKIP","_DELETE","_EXIT",
"_MOVE","__EOF","_STRING","_BEFOREROUTE","_AFTERROUTE","_DIGIT_","_RENUMBER",
"_UNPACK","_DAILY","_WEEKLY","_FLAG","_NEVER","_HARD","_SOFT","_ALWAYS","_ADDNOTE",
"_COPY","_REWRITE","_IGNORE","_DISPLAY","_DELFILE","_NEWMSG","_WRITEFILE","_APPENDTOFILE",
"_CALL","_ROUTE","_POLL","_DELETEATTACH","_CHANGEPATH","_MOVEATTACH","_COPYATTACH",
"_SPLIT","_RECODE","_HOLD","_CRASH","_DIRECT","_NORMAL","LEXERR","'+'","'-'",
"'.'","'p'","'P'","':'","'$'","'*'","'%'","'!'","'a'","'A'","'b'","'c'","'d'",
"'e'","'E'","'f'","'g'","'h'","'i'","'j'","'k'","'l'","'L'","'m'","'n'","'o'",
"'q'","'r'","'s'","'S'","'t'","'u'","'v'","'x'","'y'","'['","']'","'#'","'@'",
"'&'","'/'","Conf","ConfLine","@1","ScriptFile","TrafficLogTemplate","Semaphore",
"IncludeF","Aka","@2","@3","TimeStampFile","APktDir","Address","@4","CheckPoints",
"ChkPntMode","KillRoutedMessage","KillRMode","SysopName","TearLine","LogFile",
"LogLevel","Origin","Nodelist","NdlZone","NodelistPath","IndexFile","LoopStr",
"MaxAttachSize","MaxNodelistAge","Outbound","TempMail","TrafficLog","FileInbound",
"MaxAge","Password","@5","BadMessages","BadMsgMode","Utc","UtcOffs","ScanDir",
"@6","SDType","@7","BeforeAfter","AddSdParam","SdParam","STime","@8","@9","DaySTime",
"DaySSTime","AnyP","Time","@10","WeekSTime","WeekSSTime","Flag","Mask","@11",
"SMask","@12","PMask","@13","MParam","@14","@15","@16","@17","@18","@19","SyName",
"MString","MDigit","MNot","MsgAttr","@20","MsgFAttr","FlagsMode","@21","@22",
"FlagsChar","KludgeMask","SKludgeMask","PKludgeMask","KMParam","@23","BodyMask",
"SBodyMask","PBodyMask","BMParam","@24","ScriptMask","SScriptMask","PScriptMask",
"SCRMParam","@25","Action","@26","@27","MayBeActTime","ActionCmd","AAddNote",
"AMove","ACopy","ARewrite","@28","ADisplay","AAFlag","AFlag","ADelFile","ANewMsg",
"@29","AWriteFile","AAppendToFile","ACall","ARoute","@30","RouMode","APoll",
"@31","AChangePath","AMoveAttach","ACopyAttach","ASplit","ARecode","faddress",
"FullFtnAddr","pointaddr","PntAddr","nodeaddr","dw", NULL
};
#endif

static const short yyr1[] = {     0,
   141,   141,   142,   142,   142,   142,   142,   142,   142,   142,
   142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
   142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
   142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
   142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
   142,   142,   142,   142,   142,   143,   142,   142,   144,   145,
   146,   147,   149,   150,   148,   151,   152,   154,   153,   155,
   156,   156,   156,   157,   158,   158,   158,   159,   160,   161,
   162,   163,   164,   165,   165,   166,   167,   168,   169,   170,
   171,   172,   173,   174,   175,   177,   176,   178,   179,   179,
   179,   179,   180,   181,   181,   181,   183,   182,   184,   185,
   184,   186,   186,   187,   187,   188,   188,   188,   190,   189,
   191,   189,   192,   192,   193,   193,   193,   194,   194,   196,
   195,   197,   197,   198,   198,   199,   199,   201,   200,   203,
   202,   205,   204,   207,   208,   209,   210,   211,   212,   206,
   213,   213,   213,   213,   214,   214,   215,   215,   216,   216,
   217,   218,   217,   219,   219,   220,   221,   220,   222,   220,
   223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
   223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
   223,   223,   223,   223,   223,   223,   223,   223,   223,   224,
   225,   226,   228,   227,   229,   230,   231,   233,   232,   234,
   235,   236,   238,   237,   240,   241,   239,   242,   242,   243,
   243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
   243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
   244,   245,   246,   248,   247,   249,   250,   251,   252,   254,
   253,   255,   256,   257,   257,   259,   258,   260,   260,   260,
   260,   262,   261,   263,   264,   265,   266,   267,   268,   268,
   269,   269,   269,   269,   269,   269,   269,   269,   270,   271,
   271,   272,   273,   273
};

static const short yyr2[] = {     0,
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     0,     3,     1,     2,     2,
     3,     2,     0,     0,     5,     2,     2,     0,     3,     2,
     1,     1,     1,     2,     1,     1,     1,     2,     2,     2,
     2,     2,     3,     0,     1,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     0,     4,     2,     1,     1,
     1,     2,     2,     1,     2,     2,     0,     3,     2,     0,
     4,     1,     1,     0,     2,     1,     1,     1,     0,     3,
     0,     3,     0,     2,     1,     3,     3,     1,     1,     0,
     4,     0,     2,     1,     3,     0,     1,     0,     3,     0,
     3,     0,     3,     0,     0,     0,     0,     0,     0,    12,
     1,     1,     1,     1,     1,     1,     2,     1,     0,     1,
     1,     0,     2,     1,     2,     1,     0,     3,     0,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     2,     0,     4,     2,     2,     2,     0,     4,     2,
     2,     2,     0,     2,     0,     0,     5,     0,     3,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     2,     2,     0,     3,     2,     1,     2,     2,     0,
     5,     3,     3,     4,     2,     0,     4,     1,     1,     1,
     1,     0,     4,     2,     2,     2,     2,     2,     1,     2,
     1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
     1,     5,     1,     1
};

static const short yydefact[] = {     1,
     0,     0,     0,     0,     0,     0,     0,    68,     0,     0,
     0,     0,   107,   138,   140,   142,   208,   208,   208,   203,
   203,   203,   215,     0,     0,     0,    63,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   213,   213,   213,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    58,     2,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    56,    80,    81,    84,    87,    86,     0,    78,    46,    16,
    88,     0,   144,   144,   144,   205,     0,   206,   207,   200,
     0,   201,   202,     0,    95,    99,   101,   100,     0,    98,
    34,     0,    41,    94,    91,     7,    92,    93,    96,   104,
     0,     0,   103,    82,    79,    62,    67,    71,    72,    73,
    70,    40,    14,    45,   210,     0,   211,   212,    89,     0,
    59,    77,    76,    75,    74,    90,    42,    66,    60,    47,
    55,    54,    53,     4,     8,     5,     9,     6,    13,    19,
    43,    44,    23,    24,    17,    32,    33,    18,    25,    30,
    31,    35,    49,    50,    15,    29,    36,    51,    48,    52,
    26,    27,    28,    20,    21,    22,    10,    11,    12,    37,
    38,    39,     3,    57,    85,    83,   283,   276,   273,   277,
     0,   274,   275,    69,   269,   272,   271,     0,   110,   112,
   113,   108,   136,   139,     0,   141,   143,   155,   156,   159,
     0,   221,     0,     0,     0,     0,   244,   225,     0,     0,
   250,     0,     0,     0,     0,     0,   235,     0,     0,     0,
     0,     0,   216,   220,   222,   223,   224,   226,   227,   247,
   228,   229,   230,   231,   232,   233,   234,   236,   237,   238,
   239,   240,   102,    64,     0,   105,   106,   214,    61,     0,
   270,     0,     0,   114,   109,   137,   151,   152,   153,   154,
   145,   158,   160,   159,     0,   159,   242,   248,   241,   243,
   144,   246,   249,     0,     0,     0,   255,   258,   259,   260,
   261,   256,   262,   264,   265,   266,   267,   268,   218,     0,
    97,   278,   284,   281,   279,   280,     0,   136,     0,   209,
   157,   204,   245,     0,   252,   253,     0,     0,     0,     0,
   217,    65,     0,   116,   117,   119,   121,   115,   118,   111,
   146,   144,   254,   257,   263,     0,   282,   123,   132,     0,
   251,   219,   120,   122,   147,   130,   128,   129,   124,     0,
   125,   134,   133,     0,     0,     0,     0,     0,   148,     0,
   127,   126,   135,     0,   131,   149,   162,   161,   150,     0,
   199,   167,   169,   189,   171,   172,   173,   174,   175,   176,
   177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
   187,   188,   190,   191,   192,   193,   194,   195,   196,   197,
   198,   163,   164,   166,     0,     0,   165,   168,   170,     0,
     0
};

static const short yydefgoto[] = {     1,
    57,   214,    58,    59,    60,    61,    62,   132,   330,    63,
    64,    65,   107,    66,   151,    67,   165,    68,    69,    70,
    71,    72,    73,   216,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,   285,    85,   130,    86,   143,
    87,   112,   232,   294,   233,   338,   358,   359,   368,   369,
   373,   379,   380,   381,   385,   374,   383,   295,    88,   113,
    89,   114,    90,   115,   234,   235,   339,   370,   384,   394,
   397,   301,   240,   304,   305,   399,   400,   432,   433,   435,
   436,   434,    91,    92,    93,   120,   121,    94,    95,    96,
   116,   117,    97,    98,    99,   155,   156,   100,   124,   329,
   351,   263,   264,   265,   266,   267,   311,   268,   269,   296,
   271,   272,   314,   273,   274,   275,   276,   348,   322,   277,
   349,   278,   279,   280,   281,   282,   224,   225,   226,   335,
   227,   228
};

static const short yypact[] = {-32768,
   271,   -42,   -51,   -47,   -19,    -1,     7,-32768,    13,   -30,
    50,    43,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    42,   -36,    53,-32768,    54,    46,    55,
    60,    56,    57,    59,   -40,    87,    89,    90,    91,   -35,
    99,   100,   128,-32768,-32768,-32768,   120,   121,   125,   -58,
   123,   133,   129,   130,   134,-32768,-32768,   137,   138,   139,
   140,   141,   142,   145,   146,   147,   148,   149,   150,   151,
   153,   154,   155,   156,   157,   158,   159,   160,   163,   164,
   165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
   175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
-32768,-32768,-32768,   185,-32768,-32768,   -60,-32768,-32768,-32768,
-32768,   -23,-32768,-32768,-32768,-32768,   -54,-32768,-32768,-32768,
   -54,-32768,-32768,    10,-32768,-32768,-32768,-32768,   186,-32768,
-32768,   -60,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   187,   189,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   193,-32768,-32768,-32768,   194,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     8,   143,
   -56,-32768,-32768,-32768,-32768,-32768,   144,   161,-32768,-32768,
-32768,-32768,   188,-32768,   -52,-32768,-32768,-32768,-32768,   -88,
   -54,-32768,   195,   197,   198,   199,-32768,-32768,   200,   201,
-32768,   203,   204,   205,   -61,   -61,-32768,   206,   207,   208,
   263,   267,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   -60,-32768,-32768,-32768,-32768,   265,
-32768,   -63,   -50,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   -88,   266,   -88,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   270,   272,   273,   274,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   106,   -60,
-32768,-32768,-32768,-32768,-32768,-32768,   102,   -39,   -60,-32768,
-32768,-32768,-32768,   275,-32768,-32768,   276,   -60,   -60,    -5,
-32768,-32768,   -50,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   109,-32768,-32768,-32768,   -52,
-32768,-32768,   -45,   268,-32768,-32768,-32768,-32768,-32768,   239,
   241,   242,-32768,   -60,   240,   277,   277,   279,-32768,   280,
-32768,-32768,-32768,   -54,-32768,-32768,   243,-32768,-32768,    14,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    14,-32768,-32768,    49,    49,-32768,-32768,-32768,   246,
-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -103,-32768,-32768,
-32768,-32768,-32768,  -321,-32768,-32768,-32768,   -89,-32768,-32768,
-32768,-32768,-32768,-32768,  -111,-32768,-32768,-32768,-32768,-32768,
-32768,   -24,  -121,  -244,-32768,-32768,-32768,-32768,   -85,-32768,
-32768,  -364,-32768,-32768,-32768,    52,-32768,-32768,-32768,-32768,
    65,-32768,-32768,-32768,-32768,    58,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   225,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    94,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  -131,   131,-32768,-32768,
-32768,  -286
};


#define	YYLAST		352


static const short yytable[] = {   241,
   284,   217,   236,   237,   217,   336,   337,   238,   217,   297,
   102,   162,   163,   101,   217,   164,   302,   103,   303,   376,
   126,   127,   128,   129,   140,   109,   354,   355,   356,   357,
   244,   318,   319,   320,   321,   148,   149,   150,   229,   230,
   231,   333,   104,   218,   219,   220,   221,   218,   219,   220,
   239,   298,   299,   300,   333,   377,   378,   141,   142,   340,
   105,   342,   356,   357,   391,   392,   367,   242,   106,   243,
   438,   439,   122,   123,   108,   334,   222,   223,   401,   244,
   222,   223,   118,   119,   245,   246,   247,   248,   249,   250,
   251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
   261,   262,   157,   158,   111,   110,   125,   134,   131,   133,
  -284,   402,   403,   401,   404,   136,   135,   137,   138,   306,
   139,   405,   406,   407,   408,   409,   410,   411,   412,   413,
   414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
   424,   425,   426,   427,   428,   429,   430,   431,   144,   404,
   145,   146,   147,   331,   152,   153,   405,   406,   407,   408,
   409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
   419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
   429,   430,   431,   154,   159,   160,   161,   166,   167,   170,
   168,   169,   171,   172,   173,   174,   175,   176,   352,   343,
   177,   178,   179,   180,   181,   182,   183,   361,   184,   185,
   186,   187,   188,   189,   190,   191,   364,   365,   192,   193,
   194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
   204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
   350,   353,   290,   292,   372,   441,   366,   283,   360,   215,
   371,   286,   389,   287,   288,   289,   307,   244,   308,   309,
   310,   312,   313,   293,   315,   316,   317,   324,   325,   326,
   440,     2,   396,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,   327,   328,   332,
   341,   344,   382,   345,   346,   347,   362,   363,   386,   387,
   388,   376,   390,   393,   395,   375,   437,   398,   270,   323,
     0,   291
};

static const short yycheck[] = {   121,
   132,    65,   114,   115,    65,   292,   293,    62,    65,    62,
    62,    70,    71,    56,    65,    74,   105,    65,   107,    65,
    57,    58,    59,    60,    65,    56,    66,    67,    68,    69,
    70,    93,    94,    95,    96,    71,    72,    73,    62,    63,
    64,   105,    62,   104,   105,   106,   107,   104,   105,   106,
   105,   104,   105,   106,   105,   101,   102,    98,    99,   304,
    62,   306,    68,    69,   386,   387,   353,    58,    62,    60,
   435,   436,    21,    22,    62,   139,   137,   138,    65,    70,
   137,   138,    18,    19,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    45,    46,    62,    56,    65,    62,    56,    56,
   103,    98,    99,    65,   101,    56,    62,    62,    62,   241,
    62,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
   127,   128,   129,   130,   131,   132,   133,   134,    62,   101,
    62,    62,    62,   285,    56,    56,   108,   109,   110,   111,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   132,   133,   134,    56,    65,    65,    62,    65,    56,    56,
    62,    62,    56,    56,    56,    56,    56,    56,   330,   311,
    56,    56,    56,    56,    56,    56,    56,   339,    56,    56,
    56,    56,    56,    56,    56,    56,   348,   349,    56,    56,
    56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
    56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
   135,   140,   100,   100,   136,     0,   350,    62,   338,    65,
   362,    65,   384,    65,    62,    62,    62,    70,    62,    62,
    62,    62,    62,   103,    62,    62,    62,    62,    62,    62,
     0,     1,   394,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    65,    62,    65,
    65,    62,    65,    62,    62,    62,    62,    62,   100,    99,
    99,    65,   103,    65,    65,   370,   432,   105,   124,   256,
    -1,   221
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
{
            if (SetInclude(yyvsp[-1].ch) != 0) {
               YYABORT;
            }
         ;
    break;}
case 7:
{
               if (SetAddToNullPkt() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 14:
{
               if (SetCreateMissingBase() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 16:
{
               if (SetForceINTL() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 34:
{
               if (SetNoLogIgnore() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 40:
{
               if (SetSetViaAlways() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 41:
{
               if (SetSkipHiddenFiles() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 42:
{
               if (SetSoftCheckInNodelists() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 45:
{
               if (SetNewVia() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 46:
{
               if (SetUseOwnZone() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 47:
{
	       if (SetUseASO() != 0) {
	          YYABORT;
	       }
	    ;
    break;}
case 56:
{ YYABORT; ;
    break;}
case 57:
{ DetectError = TRUE;
         ;
    break;}
case 58:
{
            avail = 0;
         ;
    break;}
case 59:
{
               if (LoadScriptFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
             ;
    break;}
case 60:
{
                      if (SetTrafficLogTemplate(yyvsp[0].ch) != 0) {
                         YYABORT;
                      }
                   ;
    break;}
case 61:
{
             if (SetSemaphoreName(yyvsp[0].ch, yyvsp[-1].ln) != 0) {
                YYABORT;
             }
          ;
    break;}
case 62:
{ yyval.ch = yyvsp[0].ch; ;
    break;}
case 63:
{ cffa.Clean(); ;
    break;}
case 64:
{ cffa1 = cffa; cffa.Clean(); ;
    break;}
case 65:
{
               if (SetAka(cffa1, cffa) != 0) {
                  YYABORT;
               }
               cffa.Clean();
               cffa1.Clean();
            ;
    break;}
case 66:
{
               if (SetTimeStampFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 67:
{
               if (SetAPktDir(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 68:
{ cffa.Clean(); ;
    break;}
case 69:
{
               if (SetMyAddr(cffa) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 70:
{ SetCheckPoints(yyvsp[0].pmode); ;
    break;}
case 71:
{ yyval.pmode = CHECKPNT_NEVER; ;
    break;}
case 72:
{ yyval.pmode = CHECKPNT_HARD; ;
    break;}
case 73:
{ yyval.pmode = CHECKPNT_SOFT; ;
    break;}
case 74:
{ SetKillRoutedMessages(yyvsp[0].kmode); ;
    break;}
case 75:
{ yyval.kmode = KILL_ALWAYS; ;
    break;}
case 76:
{ yyval.kmode = KILL_NEVER; ;
    break;}
case 77:
{ yyval.kmode = KILL_FLAG; ;
    break;}
case 78:
{
               if (SetSysopName(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 79:
{
               if (SetTearline(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 80:
{
               if (SetLogFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 81:
{
               if (SetLogLevel(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 82:
{
               if (SetOrigin(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 83:
{
               if (SetNodelist(yyvsp[-1].ch,yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 84:
{ yyval.ln = -3; ;
    break;}
case 85:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 86:
{
               if (SetNodelistPath(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 87:
{
               if (SetIndexFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 88:
{
               if (SetLoopStr(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 89:
{
               if (SetMaxAttach(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 90:
{
               if (SetMaxNodelistAge(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 91:
{
               if (SetOutbound(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 92:
{
               if (SetTempMail(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 93:
{
               if (SetTrafficLog(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 94:
{
               if (SetFileInbound(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 95:
{
               if (SetMaxAge(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 96:
{
               if (strlen(yyvsp[0].ch) > 8){
                  yyerror("Password too long. Max password length is a 8 characters.");
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 97:
{
               if (SetPasswd(cffa, yyvsp[-2].ch) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 98:
{ 
                if (SetBadMode(yyvsp[0].bmode,FileName) != 0) {
                  YYABORT;
                }
                FileName = NULL;
              ;
    break;}
case 99:
{ yyval.bmode = SKIP; FileName = NULL;;
    break;}
case 100:
{ yyval.bmode = EXIT; FileName = NULL;;
    break;}
case 101:
{ yyval.bmode = REMOVE; FileName = NULL;;
    break;}
case 102:
{ yyval.bmode = MOVE; FileName = yyvsp[0].ch;;
    break;}
case 103:
{ 
                if (SetUTC(yyvsp[0].ln) != 0) {
                  YYABORT;
                }
              ;
    break;}
case 104:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 105:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 106:
{ yyval.ln = -yyvsp[0].ln; ;
    break;}
case 107:
{ 
              wsd = new ScanDir(); 
              CheckMem((char *)wsd); 
              renumberf = FALSE;
              unpackf = FALSE;
              arf = FALSE;
              brf = FALSE;
              _TTimes = &wsd->_Times;
              mbase = NULL;
              PrevMask = 0;
           ;
    break;}
case 108:
{
              wsd->SetBase(mbase);
              wsd->_Renumber = renumberf;
              wsd->_Unpack = unpackf;
              wsd->_FlagFile = FileName;
              ScanDirs.AddToEnd(wsd);
              if (brf) BeforeRoute = wsd;
              if (arf) AfterRoute = wsd;
           ;
    break;}
case 110:
{
             mbase = MakeBase(yyvsp[0].ch);
             if (mbase == NULL) {
                YYABORT;
             }
             if (!mbase->Set(yyvsp[0].ch,BASE_IN)) {
                delete mbase;
                mbase = NULL;
                yyerror("Unable to open message base.");
                YYABORT;
             }
             if (!mbase->CheckIn()) {
                delete mbase;
                YYABORT;
             }
          ;
    break;}
case 112:
{ brf = TRUE; ;
    break;}
case 113:
{ arf = TRUE; ;
    break;}
case 116:
{
                  if (renumberf == TRUE) {
                     yyerror("Renumber for this base already set.");
                     YYABORT;
                  } else {
                    renumberf = TRUE;
                  }
               ;
    break;}
case 117:
{
                  if (unpackf == TRUE) {
                     yyerror("Unpack for this base already set.");
                     YYABORT;
                  } else {
                     unpackf = TRUE;
                  }
                  if (Outbound == NULL) {
                     yyerror("Outbound directory not specified.");
                     YYABORT;
                  }
               ;
    break;}
case 118:
{
                  if (TimeStampFile == NULL) {
                     yyerror("You can't set scanning time without Timestamp File.");
                     YYABORT;
                  }

               ;
    break;}
case 119:
{
                  tt = new tTimes;
                  tt->_STime = TimeOfBeginOfDay(-1);
                  tt->_ETime = 0;
               ;
    break;}
case 120:
{
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                  }
               ;
    break;}
case 121:
{
                  tt = new tTimes;
                  tt->_STime = TimeOfBeginOfDay(0);
                  tt->_ETime = 0;
               ;
    break;}
case 122:
{
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                  }
               ;
    break;}
case 124:
{ 
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                     tt = new tTimes;
                  }
               ;
    break;}
case 125:
{ 
                  tt->_STime = yyvsp[0].t + TimeOfBeginOfDay(-1); 
               ;
    break;}
case 126:
{ 
                  tt->_STime = yyvsp[-2].t + TimeOfBeginOfDay(-1); 
                  tt->_ETime = yyvsp[0].t + TimeOfBeginOfDay(-1) + 59; 
               ;
    break;}
case 127:
{
                  time_t i_time;
                  time_t b_time;
                  if (yyvsp[0].t == (time_t) 0) {
                     yyerror("Time of pereodical event should be between 00:01 and 23:59");
                     YYABORT;
                  }
                  tt->_STime = TimeOfBeginOfDay(-1);
                  b_time = tt->_STime; 
                  do {
                     i_time = tt->_STime; 
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                     tt = new tTimes;
                     tt->_ETime = 0;
                     tt->_STime = i_time + yyvsp[0].t;
                  } while (tt->_STime < (b_time + (23*60*60)+(59*60)+60));
                  tt->_STime = 0;
            ;
    break;}
case 130:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 23) {
                    yyerror("Hour should be between 00 and 23");
                    YYABORT;
                 } else {
                    yyval.t = (time_t) (yyvsp[0].ln * 60);
                 }
              ;
    break;}
case 131:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 59 || yyvsp[-2].t == (time_t) -1) {
                    yyval.t = (time_t)-1;
                    yyerror("Minutes should be between 00 and 59");
                    YYABORT;
                 } else {
                    yyval.t = yyvsp[-2].t + (time_t) yyvsp[0].ln;
                    yyval.t *= 60;
                 }
              ;
    break;}
case 133:
{ 
                  CheckETTime();
                  _TTimes->AddToEnd(tt);
                  tt = new tTimes;
               ;
    break;}
case 134:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 6) {
                    yyerror("Day of week should be between 0 and 6");
                    YYABORT;
                 } else {
                    tt->_STime = TimeOfBeginOfDay(yyvsp[0].ln); 
                 }
              ;
    break;}
case 135:
{ 
                 if (yyvsp[-2].ln < 0 || yyvsp[-2].ln > 6 || yyvsp[0].ln < 0 || yyvsp[0].ln > 6) {
                    yyerror("Day of week should be between 0 and 6");
                    YYABORT;
                 } else {
                    tt->_STime = TimeOfBeginOfDay(yyvsp[-2].ln); 
                    tt->_ETime = TimeOfBeginOfDay(yyvsp[0].ln) + (23*60*60)+(59*60)+59; 
                 }
              ;
    break;}
case 136:
{ FileName = NULL; ;
    break;}
case 137:
{ FileName = strdup(yyvsp[0].ch); ;
    break;}
case 138:
{ MaskMode = 0; ;
    break;}
case 139:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 140:
{ MaskMode = 0; ;
    break;}
case 141:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 142:
{ MaskMode = 0; ;
    break;}
case 143:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 144:
{ 
               msk = new NormalMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 145:
{
               ((NormalMask *)msk)->_FromName = strdup(yyvsp[0].ch);
               cffa.Clean();
            ;
    break;}
case 146:
{
               ((NormalMask *)msk)->_FromAddr = cffa;
               if (MaskMode == 0) {
                  rc = ((NormalMask *)msk)->_FromAddr.MaskValid(); 
               } else {
                  rc = ((NormalMask *)msk)->_FromAddr.ActValid(); 
               }
               if (!rc) {
                  yyerror("Invalid 'From' Address.");
                  YYABORT;
               }
            ;
    break;}
case 147:
{
               ((NormalMask *)msk)->_ToName = strdup(yyvsp[0].ch);
               cffa.Clean();
            ;
    break;}
case 148:
{
               ((NormalMask *)msk)->_ToAddr = cffa;
               if (MaskMode == 0) {
                  rc = ((NormalMask *)msk)->_ToAddr.MaskValid(); 
               } else {
                  rc = ((NormalMask *)msk)->_ToAddr.ActValid(); 
               }
               if (!rc) {
                  yyerror("Invalid 'To' Address.");
                  YYABORT;
               }
               if ((((NormalMask *)msk)->_ToAddr.Zone() & FA_LSTMASK) && (!Ndl.Enabled())) {
                  yyerror("You can't use '#' mask without nodelist.");
                  YYABORT;
               }
               if ((((NormalMask *)msk)->_ToAddr.Point() & FA_SUBMASK) && (!Ndl.Enabled())) {
                  yyerror("You can't use '&' mask without nodelist.");
                  YYABORT;
               }
            ;
    break;}
case 149:
{ 
               ((NormalMask *)msk)->_Subject = strdup(yyvsp[0].ch);
               NoTokensF = TRUE; 
            ;
    break;}
case 150:
{ 
               NoTokensF = FALSE; 
            ;
    break;}
case 152:
{ yyval.ch = "$"; ;
    break;}
case 153:
{ yyval.ch = "*"; ;
    break;}
case 154:
{ yyval.ch = "%"; ;
    break;}
case 156:
{ yyval.ch = "*"; ;
    break;}
case 157:
{
               if (yyvsp[0].ln > 65535) {
                  yyerror("Parameter shoul be less that 65535");
                  YYABORT;
               }
               yyval.ln = yyvsp[-1].ln | yyvsp[0].ln;
            ;
    break;}
case 158:
{ yyval.ln = -1; ;
    break;}
case 159:
{ yyval.ln = 0; ;
    break;}
case 160:
{ yyval.ln = 0x08000000; ;
    break;}
case 162:
{ FlagMode = 1; ;
    break;}
case 167:
{ FlagMode = 1; ;
    break;}
case 169:
{ FlagMode = 2; ;
    break;}
case 171:
{ ((NormalMask *)msk)->fFileAttach = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 172:
{ /* CheckMaxAttach size*/
               if (CheckMaskMode("A") != 0) {
                  YYABORT;
               }
               if (((NormalMask *)msk)->sd->_MaxAttachSize == 0 && MaxAttachSize == 0) {
                  yyerror("Not one (global or local) MaxAttachSize is not defined.");
                  YYABORT;
               }
               ((NormalMask *)msk)->fMaxAttach = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 173:
{ ((NormalMask *)msk)->fARQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 174:
{ ((NormalMask *)msk)->fCrash = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 175:
{ ((NormalMask *)msk)->fDIR = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 176:
{ /* Empty message */
               if (CheckMaskMode("e") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fEmpty = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 177:
{ /* Check echomail */
               if (CheckMaskMode("E") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fEchomail = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 178:
{ ((NormalMask *)msk)->fFileRequest = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 179:
{ /* Check age */
               if (CheckMaskMode("g") != 0) {
                  YYABORT;
               }
               if (((NormalMask *)msk)->sd->_MaxAge == 0 && MaxAge == 0) {
                  yyerror("Not one (global or local) MaxAge is not defined.");
                  YYABORT;
               }
               ((NormalMask *)msk)->fMaxAge = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 180:
{ ((NormalMask *)msk)->fHold = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 181:
{ ((NormalMask *)msk)->fTransit = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 182:
{ ((NormalMask *)msk)->fKFS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 183:
{ ((NormalMask *)msk)->fKillSend = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 184:
{ ((NormalMask *)msk)->fLocal = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 185:
{ ((NormalMask *)msk)->fLok = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 186:
{ ((NormalMask *)msk)->fIMM = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 187:
{ ((NormalMask *)msk)->fCFM = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 188:
{ ((NormalMask *)msk)->fOrphan = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 189:
{ ((NormalMask *)msk)->fPrivate = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 190:
{ ((NormalMask *)msk)->fRRQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 191:
{ ((NormalMask *)msk)->fReceived = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 192:
{ ((NormalMask *)msk)->fSend = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 193:
{ ((NormalMask *)msk)->fAS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 194:
{ ((NormalMask *)msk)->fTFS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 195:
{ ((NormalMask *)msk)->fFURQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 196:
{ ((NormalMask *)msk)->fScanned = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 197:
{ /* Check existing attach */
               if (CheckMaskMode("x") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fAttExists = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 198:
{ ((NormalMask *)msk)->fIRR = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 199:
{
               if (CheckMaskMode("loop flag") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fLoop = (FlagMode == 2) ? 2 : 1;
               if (((NormalMask *)msk)->Loops != (unsigned int)-1) {
                  yyerror("Only one loop count should be in mask.");
                  YYABORT;
               }
               ((NormalMask *)msk)->Loops = yyvsp[0].ln;
            ;
    break;}
case 200:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 201:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 202:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 203:
{ 
               msk = new KludgeMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 204:
{
               ((KludgeMask *)msk)-> _KludgeName = strdup(yyvsp[-2].ch);
               ((KludgeMask *)msk)-> _KludgeBody = strdup(yyvsp[-1].ch);
               ((KludgeMask *)msk)-> _Times = yyvsp[0].ln;
            ;
    break;}
case 205:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 206:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 207:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 208:
{ 
               msk = new BodyMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 209:
{
               ((BodyMask *)msk)-> _Body = strdup(yyvsp[-2].ch);
               ((BodyMask *)msk)-> _Lines = yyvsp[-1].ln;
               ((BodyMask *)msk)-> _Bytes = yyvsp[0].ln;
            ;
    break;}
case 210:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(ScriptMask *)msk);
            ;
    break;}
case 211:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(ScriptMask *)msk);
            ;
    break;}
case 212:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(ScriptMask *)msk);
            ;
    break;}
case 213:
{ 
               msk = new ScriptMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 214:
{
               ((ScriptMask *)msk)->_ScriptName = strdup(yyvsp[0].ch);
               ((ScriptMask *)msk)->_WordExec = ficlLookup(((ScriptMask *)msk)-> _ScriptName);
               if (((ScriptMask *)msk)->_WordExec == NULL) {
                  yyerror("Word not found in scripts.");
                  YYABORT;
               }
            ;
    break;}
case 215:
{
          if (PrevMask == 0) {
             yyerror("Action without Mask.");
             YYABORT;
          }
          wsd = ScanDirs.GetLast();
          PrevMask = 1;
          act = new Action();
          act->sd = wsd;
          act->Before = BeforeRoute;
          act->After = AfterRoute;
         _TTimes = &act->_Times;       
       ;
    break;}
case 216:
{
          LastDo->AddAction(*act);
       ;
    break;}
case 221:
{ act->_Act = ACT_DELETE; ;
    break;}
case 225:
{ act->_Act = ACT_IGNORE; ;
    break;}
case 235:
{ act->_Act = ACT_DELETEATTACH; ;
    break;}
case 241:
{
            act->_Act = ACT_ADDNOTE;
            act->_Tpl = new Template();
            if (!act->_Tpl->Set(yyvsp[0].ch)) {
               yyerror("Template file is not accesible.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               YYABORT;
            }
            act->_Tpl->sd = ScanDirs.GetLast();
         ;
    break;}
case 242:
{
            act->_Act = ACT_MOVE;
            act->_Base = MakeBase(yyvsp[0].ch);
            if (act->_Base == NULL) {
               YYABORT;
            }
            if (!act->_Base->Set(yyvsp[0].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
         ;
    break;}
case 243:
{
            act->_Act = ACT_COPY;
            act->_Base = MakeBase(yyvsp[0].ch);
            if (act->_Base == NULL) {
               YYABORT;
            }
            if (!act->_Base->Set(yyvsp[0].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
         ;
    break;}
case 244:
{
              MaskMode = 1;
              act->_Act = ACT_REWRITE;
           ;
    break;}
case 245:
{
              act->_Mask = msk;
           ;
    break;}
case 246:
{ 
            act->_Act = ACT_DISPLAY; 
            act->_TplName = strdup(yyvsp[0].ch);
         ;
    break;}
case 247:
{
            act->_Act = ACT_FLAG; 
            act->_OutDir = strdup(yyvsp[0].ch);
         ;
    break;}
case 248:
{ yyval.ch = yyvsp[0].ch; ;
    break;}
case 249:
{
            act->_Act = ACT_DELFILE;
            act->_OutDir = strdup(yyvsp[0].ch);
         ;
    break;}
case 250:
{
            MaskMode = 1;
            act->_Act = ACT_NEWMSG;
         ;
    break;}
case 251:
{
            act->_Tpl = new Template();
            if (!act->_Tpl->Set(yyvsp[-2].ch)) {
               yyerror("Template file is not accesible.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               YYABORT;
            }
            act->_Tpl->sd =  ScanDirs.GetLast();
            act->_Base = MakeBase(yyvsp[-1].ch);
            if (act->_Base == NULL || !act->_Base->Set(yyvsp[-1].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
            act->_Mask = msk;

         ;
    break;}
case 252:
{
              act->_Act = ACT_WRITEFILE;
              act->_Tpl = new Template();
              if (!act->_Tpl->Set(yyvsp[-1].ch)) {
                 yyerror("Template file is not accesible.");
                 delete act->_Tpl;
                 act->_Tpl = NULL;
                 YYABORT;
              }
              act->_Tpl->sd =  ScanDirs.GetLast();
              act->_OutDir = strdup(yyvsp[0].ch);
           ;
    break;}
case 253:
{
                   act->_Act = ACT_ADDFILE;
                   act->_Tpl = new Template();
                   if (!act->_Tpl->Set(yyvsp[-1].ch)) {
                      yyerror("Template file is not accesible.");
                      delete act->_Tpl;
                      act->_Tpl = NULL;
                      YYABORT;
                   }
                   act->_Tpl->sd =  ScanDirs.GetLast();
                   act->_OutDir = strdup(yyvsp[0].ch);
              ;
    break;}
case 254:
{
           act->_Act = ACT_CALL;
           act->_Tpl = new Template();
           if (!act->_Tpl->Set(yyvsp[-2].ch)) {
              yyerror("Template file is not accesible.");
              delete act->_Tpl;
              act->_Tpl = NULL;
              YYABORT;
           }
           act->_Tpl->sd =  ScanDirs.GetLast();
           act->_OutDir = strdup(yyvsp[-1].ch);
           act->_TplName = strdup(yyvsp[0].ch);
      ;
    break;}
case 255:
{
           act->_Act = ACT_CALL;
           act->_TplName = strdup(yyvsp[0].ch);
      ;
    break;}
case 256:
{ cffa.Clean(); ;
    break;}
case 257:
{
          act->_Act = ACT_ROUTE;
          if (act->sd == act->Before|| act->sd == act->After) {
             yyerror("You can not use the Action Route in 'ScanDir: @AfterRoute|@BeforeRoute'");
             YYABORT;
          }
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid routing address.");
             YYABORT;
          }
       ;
    break;}
case 258:
{ yyval.pktmode = F_HOLD; ;
    break;}
case 259:
{ yyval.pktmode = F_CRASH; ;
    break;}
case 260:
{ yyval.pktmode = F_DIRECT; ;
    break;}
case 261:
{ yyval.pktmode = F_NORMAL; ;
    break;}
case 262:
{ cffa.Clean(); ;
    break;}
case 263:
{
          act->_Act = ACT_POLL;
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid poll address.");
             YYABORT;
          }
       ;
    break;}
case 264:
{
               act->_Act = ACT_CHANGEPATH;
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 265:
{
               act->_Act = ACT_MOVEATTACH;
               if (!DirExists(yyvsp[0].ch)) {
                  yyerror("Target directory not found.");
                  YYABORT;
               }
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 266:
{
               act->_Act = ACT_COPYATTACH;
               if (!DirExists(yyvsp[0].ch)) {
                  yyerror("Target directory not found.");
                  YYABORT;
               }
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 267:
{
               act->_Act = ACT_SPLIT;
               if (yyvsp[0].ln < 1 || yyvsp[0].ln > 65535) {
                  yyerror("Parameter 'Lines' should be positive integer between 1 and 65535");
                  YYABORT;
               }
               act->_Lines = yyvsp[0].ln;
            ;
    break;}
case 268:
{
               FILE *fp;
               char buf[512],*p,*q;
               int in,on,count;
               int line;

                  act->_Act = ACT_RECODE;
                  fp = fopen(yyvsp[0].ch,"r");
                  if (fp == NULL) {
                     yyerror("Unable to open file");
                     YYABORT;
                  }
                  act->_TplName = (char *)malloc(256);
                  CheckMem(act->_TplName);
                  for (count = 0; count < 256; count++) act->_TplName[count] = (char) count;
                  count = 0;	 
                  line = 0;

                  while (fgets((char*)buf,sizeof(buf),fp)) {
                     line++;
                     p = strtok((char*)buf," \t\n#");
                     q = strtok(NULL," \t\n#");
                     if (p != NULL && q != NULL) {
                        in = ctoi((char *)p);
                        if (in > 255) {
                           sprintf(buf, "%s: Error in line %d.", yyvsp[0].ch, line);
                           yyerror(buf);
                           fclose(fp);
                           free(act->_TplName);
                           YYABORT;
                        }
                        on=ctoi((char *)q);
                        if (in != 0 && on != 0) {
                           if (count++ < 256 ) {
                              act->_TplName[in]=on; 
                           } else { 
                              sprintf(buf,"Char map table \"%s\" is big",yyvsp[0].ch); 
                              yyerror(buf);
                              fclose(fp);
                              free(act->_TplName);
                              YYABORT;
                           }
                        }
                     } /* if */
                  } /* While */
                  fclose(fp);
            ;
    break;}
case 270:
{ cffa.Zone(cffa.Zone() | FA_NOTMASK); ;
    break;}
case 273:
{
                  cffa.Zone(FA_ANYMASK);
                  cffa.Net(FA_ANYMASK);
                  cffa.Node(FA_ANYMASK);
                  cffa.Point(FA_ANYMASK);
               ;
    break;}
case 274:
{
                  cffa.Zone(FA_LSTMASK);
                  cffa.Net(FA_LSTMASK);
                  cffa.Node(FA_LSTMASK);
                  cffa.Point(FA_LSTMASK);
               ;
    break;}
case 275:
{
                  cffa.Zone(FA_OURMASK);
                  cffa.Net(FA_OURMASK);
                  cffa.Node(FA_OURMASK);
                  cffa.Point(FA_OURMASK);
               ;
    break;}
case 276:
{
                  cffa.Zone(FA_FROMMASK);
                  cffa.Net(FA_FROMMASK);
                  cffa.Node(FA_FROMMASK);
                  cffa.Point(FA_FROMMASK);
               ;
    break;}
case 277:
{
                  cffa.Zone(FA_TOMASK);
                  cffa.Net(FA_TOMASK);
                  cffa.Node(FA_TOMASK);
                  cffa.Point(FA_TOMASK);
               ;
    break;}
case 278:
{
                  if (yyvsp[0].ln != 0) {
                     yyerror("parse error");
                     YYABORT;
                  }
                  cffa.Zone(FA_TOMASK);
                  cffa.Net(FA_TOMASK);
                  cffa.Node(FA_TOMASK);
                  cffa.Point(0);
               ;
    break;}
case 280:
{ cffa.Point(yyvsp[0].ln); ;
    break;}
case 281:
{ cffa.Point(FA_SUBMASK); ;
    break;}
case 282:
{ 
               cffa.Zone(yyvsp[-4].ln); 
               cffa.Net(yyvsp[-2].ln); 
               cffa.Node(yyvsp[0].ln); 
               cffa.Point(0); 
            ;
    break;}
case 283:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 284:
{ yyval.ln = FA_ANYMASK; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}



